diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
index 746ed8185..85462cd05 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.world.generate.feature;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.block.material.Material;
@@ -77,7 +76,7 @@ public class WorldFeatureLake extends WorldFeature
                     {
                         return false;
                     }
-                    if (world.getBlockId(x + dx, y + dy, z + dz) == Blocks.ICE.id)
+                    if (world.getBlockId(x + dx, y + dy, z + dz) == Blocks.ICE.id())
                     {
                     	return false;
                     }
@@ -93,7 +92,7 @@ public class WorldFeatureLake extends WorldFeature
             {
                 for(int dy = 0; dy < 8; dy++)
                 {
-                    if(shouldPlaceLiquid[(dx * 16 + dz) * 8 + dy] && world.getBlockId(x + dx, y + dy, z + dz) != Blocks.BEDROCK.id)
+                    if(shouldPlaceLiquid[(dx * 16 + dz) * 8 + dy] && world.getBlockId(x + dx, y + dy, z + dz) != Blocks.BEDROCK.id())
                     {
                         world.setBlockWithNotify(x + dx, y + dy, z + dz, dy < 4 ? liquidId : 0);
                     }
@@ -109,9 +108,9 @@ public class WorldFeatureLake extends WorldFeature
             {
                 for(int dy = 4; dy < 8; dy++)
                 {
-                    if(shouldPlaceLiquid[(dx * 16 + dz) * 8 + dy] && world.getBlockId(x + dx, y + dy - 1, z + dz) != Blocks.BEDROCK.id && world.getBlockId(x + dx, (y + dy) - 1, z + dz) == Blocks.DIRT.id && world.getSavedLightValue(LightLayer.Sky, x + dx, y + dy, z + dz) > 0)
+                    if(shouldPlaceLiquid[(dx * 16 + dz) * 8 + dy] && world.getBlockId(x + dx, y + dy - 1, z + dz) != Blocks.BEDROCK.id() && world.getBlockId(x + dx, (y + dy) - 1, z + dz) == Blocks.DIRT.id() && world.getSavedLightValue(LightLayer.Sky, x + dx, y + dy, z + dz) > 0)
                     {
-                        world.setBlock(x + dx, (y + dy) - 1, z + dz, Blocks.GRASS.id);
+                        world.setBlock(x + dx, (y + dy) - 1, z + dz, Blocks.GRASS.id());
                     }
                 }
 
@@ -119,7 +118,7 @@ public class WorldFeatureLake extends WorldFeature
 
         }
 
-        if(Blocks.blocksList[liquidId].blockMaterial == Material.lava)
+        if(Blocks.blocksList[liquidId].getMaterial() == Material.lava)
         {
             for(int dx = 0; dx < 16; dx++)
             {
@@ -128,7 +127,7 @@ public class WorldFeatureLake extends WorldFeature
                     for(int dy = 0; dy < 8; dy++)
                     {
                         boolean flag1 = !shouldPlaceLiquid[(dx * 16 + dz) * 8 + dy] && (dx < 15 && shouldPlaceLiquid[((dx + 1) * 16 + dz) * 8 + dy] || dx > 0 && shouldPlaceLiquid[((dx - 1) * 16 + dz) * 8 + dy] || dz < 15 && shouldPlaceLiquid[(dx * 16 + (dz + 1)) * 8 + dy] || dz > 0 && shouldPlaceLiquid[(dx * 16 + (dz - 1)) * 8 + dy] || dy < 7 && shouldPlaceLiquid[(dx * 16 + dz) * 8 + (dy + 1)] || dy > 0 && shouldPlaceLiquid[(dx * 16 + dz) * 8 + (dy - 1)]);
-                        if(flag1 && (dy < 4 || random.nextInt(2) != 0) && world.getBlockId(x + dx, y + dy, z + dz) != Blocks.BEDROCK.id && world.getBlockMaterial(x + dx, y + dy, z + dz).isSolid())
+                        if(flag1 && (dy < 4 || random.nextInt(2) != 0) && world.getBlockId(x + dx, y + dy, z + dz) != Blocks.BEDROCK.id() && world.getBlockMaterial(x + dx, y + dy, z + dz).isSolid())
                         {
                             world.setBlock(x + dx, y + dy, z + dz, world.getWorldType().getFillerBlockId());
                         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
index a19c45dfe..8dfb139ab 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.world.generate.feature;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
@@ -17,32 +16,32 @@ public class WorldFeatureLiquid extends WorldFeature
     @Override
 	public boolean place(World world, Random random, int x, int y, int z)
     {
-        if(world.getBlockId(x, y + 1, z) != Blocks.STONE.id)
+        if(world.getBlockId(x, y + 1, z) != Blocks.STONE.id())
         {
             return false;
         }
-        if(world.getBlockId(x, y - 1, z) != Blocks.STONE.id)
+        if(world.getBlockId(x, y - 1, z) != Blocks.STONE.id())
         {
             return false;
         }
-        if(world.getBlockId(x, y, z) != 0 && world.getBlockId(x, y, z) != Blocks.STONE.id)
+        if(world.getBlockId(x, y, z) != 0 && world.getBlockId(x, y, z) != Blocks.STONE.id())
         {
             return false;
         }
         int l = 0;
-        if(world.getBlockId(x - 1, y, z) == Blocks.STONE.id)
+        if(world.getBlockId(x - 1, y, z) == Blocks.STONE.id())
         {
             l++;
         }
-        if(world.getBlockId(x + 1, y, z) == Blocks.STONE.id)
+        if(world.getBlockId(x + 1, y, z) == Blocks.STONE.id())
         {
             l++;
         }
-        if(world.getBlockId(x, y, z - 1) == Blocks.STONE.id)
+        if(world.getBlockId(x, y, z - 1) == Blocks.STONE.id())
         {
             l++;
         }
-        if(world.getBlockId(x, y, z + 1) == Blocks.STONE.id)
+        if(world.getBlockId(x, y, z + 1) == Blocks.STONE.id())
         {
             l++;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
index dc8d1fe4f..685f6b906 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
@@ -1,8 +1,8 @@
 package net.minecraft.core.world.generate.feature;
 
-import net.minecraft.core.block.BlockLeavesBase;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFlowerStackable;
+import net.minecraft.core.block.BlockLogicFlowerStackable;
+import net.minecraft.core.block.BlockLogicLeavesBase;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
@@ -19,7 +19,7 @@ public class WorldFeatureMeadow extends WorldFeature
     @Override
     public boolean place(World world, Random random, int x, int y, int z)
     {
-        for(int l; ((l = world.getBlockId(x, y, z)) == 0 || Blocks.blocksList[l] instanceof BlockLeavesBase) && y > 0; y--) { }
+        for(int l; ((l = world.getBlockId(x, y, z)) == 0 || Block.hasLogicClass(Blocks.blocksList[l], BlockLogicLeavesBase.class)) && y > 0; y--) { }
         for(int i1 = 0; i1 < 128; i1++)
         {
             int j1 = (x + random.nextInt(8)) - random.nextInt(8);
@@ -32,7 +32,7 @@ public class WorldFeatureMeadow extends WorldFeature
 
             if(world.isAirBlock(j1, k1, l1) && Blocks.blocksList[flowerId].canBlockStay(world, j1, k1, l1))
             {
-                final int meta = BlockFlowerStackable.setStackCount(0, WorldFeatureFlowers.getStackSize(random));
+                final int meta = BlockLogicFlowerStackable.setStackCount(0, WorldFeatureFlowers.getStackSize(random));
                 world.setBlockAndMetadata(j1, k1, l1, flowerId, meta);
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMudPatch.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMudPatch.java
index 3a26d960d..99a477556 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMudPatch.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMudPatch.java
@@ -22,9 +22,9 @@ public class WorldFeatureMudPatch extends WorldFeature
                 float offset = (float) noise.getValue(chunkX / 30D, yPos / 30D, chunkZ / 30D) * 0.75f;
                 if(offset >= 0.125F) {
                     for(int i = 0; i < 5; i++) {
-                        if (world.getBlockId(chunkX, yPos - i, chunkZ) == Blocks.GRASS.id ||
-                                world.getBlockId(chunkX, yPos - i, chunkZ) == Blocks.DIRT.id) {
-                            world.setBlock(chunkX, yPos - i, chunkZ, Blocks.MUD.id);
+                        if (world.getBlockId(chunkX, yPos - i, chunkZ) == Blocks.GRASS.id() ||
+                                world.getBlockId(chunkX, yPos - i, chunkZ) == Blocks.DIRT.id()) {
+                            world.setBlock(chunkX, yPos - i, chunkZ, Blocks.MUD.id());
                         }
                     }
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
index cca2f0297..565b7a070 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.world.generate.feature;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
@@ -18,32 +17,32 @@ public class WorldFeatureNetherLava extends WorldFeature
     @Override
 	public boolean place(World world, Random random, int x, int y, int z)
     {
-        if(world.getBlockId(x, y + 1, z) != Blocks.COBBLE_NETHERRACK.id)
+        if(world.getBlockId(x, y + 1, z) != Blocks.COBBLE_NETHERRACK.id())
         {
             return false;
         }
-        if(world.getBlockId(x, y, z) != 0 && world.getBlockId(x, y, z) != Blocks.COBBLE_NETHERRACK.id)
+        if(world.getBlockId(x, y, z) != 0 && world.getBlockId(x, y, z) != Blocks.COBBLE_NETHERRACK.id())
         {
             return false;
         }
         int l = 0;
-        if(world.getBlockId(x - 1, y, z) == Blocks.COBBLE_NETHERRACK.id)
+        if(world.getBlockId(x - 1, y, z) == Blocks.COBBLE_NETHERRACK.id())
         {
             l++;
         }
-        if(world.getBlockId(x + 1, y, z) == Blocks.COBBLE_NETHERRACK.id)
+        if(world.getBlockId(x + 1, y, z) == Blocks.COBBLE_NETHERRACK.id())
         {
             l++;
         }
-        if(world.getBlockId(x, y, z - 1) == Blocks.COBBLE_NETHERRACK.id)
+        if(world.getBlockId(x, y, z - 1) == Blocks.COBBLE_NETHERRACK.id())
         {
             l++;
         }
-        if(world.getBlockId(x, y, z + 1) == Blocks.COBBLE_NETHERRACK.id)
+        if(world.getBlockId(x, y, z + 1) == Blocks.COBBLE_NETHERRACK.id())
         {
             l++;
         }
-        if(world.getBlockId(x, y - 1, z) == Blocks.COBBLE_NETHERRACK.id)
+        if(world.getBlockId(x, y - 1, z) == Blocks.COBBLE_NETHERRACK.id())
         {
             l++;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
index 72679bd27..da6e2bc97 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
@@ -81,9 +81,9 @@ public class WorldFeatureOre extends WorldFeature
                         	else
                         	{
                         		int id = world.getBlockId(x, y, z);
-                        		if (id == Blocks.STONE.id || id == Blocks.COBBLE_NETHERRACK.id ||
-                        				id == Blocks.BASALT.id || id == Blocks.LIMESTONE.id ||
-                        				id == Blocks.GRANITE.id)
+                        		if (id == Blocks.STONE.id() || id == Blocks.COBBLE_NETHERRACK.id() ||
+                        				id == Blocks.BASALT.id() || id == Blocks.LIMESTONE.id() ||
+                        				id == Blocks.GRANITE.id())
                         		{
                         			world.setBlock(x, y, z, minableBlockId);
                         		}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePermaice.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePermaice.java
index 2e7aa4355..4e2040184 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePermaice.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePermaice.java
@@ -13,11 +13,11 @@ public class WorldFeaturePermaice extends WorldFeature{
     private int generateInId;
 
     @MethodParametersAnnotation(names = {"numberOfBlocks", "block"})
-    public WorldFeaturePermaice(int numberOfBlocks, Block block)
+    public WorldFeaturePermaice(int numberOfBlocks, Block<?> block)
     {
-        blockId = Blocks.PERMAICE.id;
+        blockId = Blocks.PERMAICE.id();
         this.numberOfBlocks = numberOfBlocks;
-        this.generateInId = block.id;
+        this.generateInId = block.id();
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumice.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumice.java
index 41c0c9f24..759a6fc2c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumice.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumice.java
@@ -17,10 +17,10 @@ public class WorldFeaturePumice extends WorldFeature{
     }
 
     @MethodParametersAnnotation(names = {"numberOfBlocks", "block"})
-    public WorldFeaturePumice(int numberOfBlocks, Block block)
+    public WorldFeaturePumice(int numberOfBlocks, Block<?> block)
     {
         this.numberOfBlocks = numberOfBlocks;
-        this.generateInId = block.id;
+        this.generateInId = block.id();
     }
 
     @Override
@@ -72,7 +72,7 @@ public class WorldFeaturePumice extends WorldFeature{
                         {
                             if(world.getBlockId(k2, l2, i3) == generateInId)
                             {
-                                world.setBlock(k2, l2, i3, Blocks.PUMICE_WET.id);
+                                world.setBlock(k2, l2, i3, Blocks.PUMICE_WET.id());
                             }
                         }
                     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumpkin.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumpkin.java
index 10c97ea1d..d5fa52042 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumpkin.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumpkin.java
@@ -20,11 +20,11 @@ public class WorldFeaturePumpkin extends WorldFeature
             int i1 = (x + random.nextInt(8)) - random.nextInt(8);
             int j1 = (y + random.nextInt(4)) - random.nextInt(4);
             int k1 = (z + random.nextInt(8)) - random.nextInt(8);
-            if(world.isAirBlock(i1, j1, k1) && world.getBlockId(i1, j1 - 1, k1) == Blocks.GRASS.id && Blocks.PUMPKIN.canPlaceBlockAt(world, i1, j1, k1))
+            if(world.isAirBlock(i1, j1, k1) && world.getBlockId(i1, j1 - 1, k1) == Blocks.GRASS.id() && Blocks.PUMPKIN.canPlaceBlockAt(world, i1, j1, k1))
             {
                 if(random.nextInt(50)== 0)
-                    world.setBlockAndMetadata(i1, j1, k1, Blocks.PUMPKIN_CARVED_IDLE.id, random.nextInt(4));
-                else    world.setBlockWithNotify(i1, j1, k1, Blocks.PUMPKIN.id);
+                    world.setBlockAndMetadata(i1, j1, k1, Blocks.PUMPKIN_CARVED_IDLE.id(), random.nextInt(4));
+                else    world.setBlockWithNotify(i1, j1, k1, Blocks.PUMPKIN.id());
             }
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRichScorchedDirt.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRichScorchedDirt.java
index d4a65e992..40bb29f19 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRichScorchedDirt.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRichScorchedDirt.java
@@ -21,8 +21,8 @@ public class WorldFeatureRichScorchedDirt extends WorldFeature
             for(int y1 = y - 2; y1 <= y+2; y1++ ) {
                 for(int z1 = z - numberOfBlocks; z1 < z + numberOfBlocks; z1++ ) {
                     if(random.nextInt(8) == 0){
-                        if(world.getBlockId(x1, y1, z1) == Blocks.DIRT_SCORCHED.id)
-                            world.setBlock(x1, y1, z1, Blocks.DIRT_SCORCHED_RICH.id);
+                        if(world.getBlockId(x1, y1, z1) == Blocks.DIRT_SCORCHED.id())
+                            world.setBlock(x1, y1, z1, Blocks.DIRT_SCORCHED_RICH.id());
                     }
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSpinifexPatch.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSpinifexPatch.java
index 7cfb9f89d..c362c5857 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSpinifexPatch.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSpinifexPatch.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLeavesBase;
+import net.minecraft.core.block.BlockLogicLeavesBase;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
@@ -12,7 +12,7 @@ public class WorldFeatureSpinifexPatch extends WorldFeature
     @Override
     public boolean place(World world, Random random, int x, int y, int z)
     {
-        for(int l; ((l = world.getBlockId(x, y, z)) == 0 || Blocks.blocksList[l] instanceof BlockLeavesBase) && y > 0; y--) { }
+        for(int l; ((l = world.getBlockId(x, y, z)) == 0 || Block.hasLogicClass(Blocks.blocksList[l], BlockLogicLeavesBase.class)) && y > 0; y--) { }
         for(int i1 = 0; i1 < 64; i1++)
         {
             int j1 = (x + random.nextInt(4)) - random.nextInt(4);
@@ -23,7 +23,7 @@ public class WorldFeatureSpinifexPatch extends WorldFeature
 
             if(world.isAirBlock(j1, k1, l1) && Blocks.SPINIFEX.canBlockStay(world, j1, k1, l1))
             {
-                world.setBlockAndMetadata(j1, k1, l1, Blocks.SPINIFEX.id, meta);
+                world.setBlockAndMetadata(j1, k1, l1, Blocks.SPINIFEX.id(), meta);
             }
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSponge.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSponge.java
index a6bafd3ab..5ab9f583f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSponge.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSponge.java
@@ -11,20 +11,20 @@ public class WorldFeatureSponge extends WorldFeature
     @Override
 	public boolean place(World world, Random random, int x, int y, int z)
     {
-        if (world.getBlockId(x, y - 1, z) != Blocks.FLUID_WATER_STILL.id)
+        if (world.getBlockId(x, y - 1, z) != Blocks.FLUID_WATER_STILL.id())
             return false;
         for(int l = 0; l < 16; l++) {
             int i1 = (x + random.nextInt(8)) - random.nextInt(8);
             int k1 = (z + random.nextInt(8)) - random.nextInt(8);
 
-            for (; world.getBlockId(i1, y - 1, k1) == Blocks.FLUID_WATER_STILL.id; y--);
+            for (; world.getBlockId(i1, y - 1, k1) == Blocks.FLUID_WATER_STILL.id(); y--);
 
-            if(world.getBlockId(i1, y-1, k1) != Blocks.SAND.id && world.getBlockId(i1, y-1, k1) != Blocks.DIRT.id)
+            if(world.getBlockId(i1, y-1, k1) != Blocks.SAND.id() && world.getBlockId(i1, y-1, k1) != Blocks.DIRT.id())
                 continue;
             if(world.getBlockId(i1, y+1, k1) == 0)
                 continue;
 
-            world.setBlockRaw(i1, y, k1, Blocks.SPONGE_WET.id);
+            world.setBlockRaw(i1, y, k1, Blocks.SPONGE_WET.id());
         }
         return true;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCane.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCane.java
index b9bd3a0b2..26491dc96 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCane.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCane.java
@@ -30,7 +30,7 @@ public class WorldFeatureSugarCane extends WorldFeature
             {
                 if(Blocks.SUGARCANE.canBlockStay(world, i1, j1 + i2, k1))
                 {
-                    world.setBlock(i1, j1 + i2, k1, Blocks.SUGARCANE.id);
+                    world.setBlock(i1, j1 + i2, k1, Blocks.SUGARCANE.id());
                 }
             }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCaneTall.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCaneTall.java
index 50907c4ba..ad169f975 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCaneTall.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCaneTall.java
@@ -30,7 +30,7 @@ public class WorldFeatureSugarCaneTall extends WorldFeature
             {
                 if(Blocks.SUGARCANE.canBlockStay(world, i1, j1 + i2, k1))
                 {
-                    world.setBlock(i1, j1 + i2, k1, Blocks.SUGARCANE.id);
+                    world.setBlock(i1, j1 + i2, k1, Blocks.SUGARCANE.id());
                 }
             }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTallGrass.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTallGrass.java
index f7295c918..1f4de8cf7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTallGrass.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTallGrass.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
-import net.minecraft.core.block.BlockLeavesBase;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicLeavesBase;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
@@ -20,7 +20,7 @@ public class WorldFeatureTallGrass extends WorldFeature
 	public boolean place(World world, Random random, int x, int y, int z)
     {
         int l;
-        while (((l = world.getBlockId(x, y, z)) == 0 || Blocks.blocksList[l] instanceof BlockLeavesBase) && y > 0) {
+        while (((l = world.getBlockId(x, y, z)) == 0 ||  Block.hasLogicClass(Blocks.blocksList[l], BlockLogicLeavesBase.class)) && y > 0) {
             y--;
         }
         for(int i1 = 0; i1 < 128; i1++)
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java
index b232adf65..15a757d7c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java
@@ -58,7 +58,7 @@ public class WorldFeatureTree extends WorldFeature
             return false;
         }
         int idBelow = world.getBlockId(x, y - 1, z);
-        if(!Block.hasTag(idBelow, BlockTags.GROWS_TREES) || y >= world.getHeightBlocks() - treeHeight - 1)
+        if(!Blocks.hasTag(idBelow, BlockTags.GROWS_TREES) || y >= world.getHeightBlocks() - treeHeight - 1)
         {
             return false;
         }
@@ -105,25 +105,25 @@ public class WorldFeatureTree extends WorldFeature
      * Replace grass blocks below the tree with dirt 
      */
     public static void onTreeGrown(World world, int x, int y, int z) {
-        Block dirt = WorldFeatureTree.getDirtForGrass(world.getBlockId(x, y - 1, z));
+        Block<?> dirt = WorldFeatureTree.getDirtForGrass(world.getBlockId(x, y - 1, z));
         if(dirt != null) {
-        	world.setBlockWithNotify(x, y - 1, z, dirt.id);
+        	world.setBlockWithNotify(x, y - 1, z, dirt.id());
         }
     }
     
-    public static Block getDirtForGrass(int id) {
+    public static Block<?> getDirtForGrass(int id) {
     	// TODO make this not hardcoded
-    	if(id == Blocks.GRASS.id || id == Blocks.GRASS_RETRO.id) {
+    	if(id == Blocks.GRASS.id() || id == Blocks.GRASS_RETRO.id()) {
     		return Blocks.DIRT;
     	}
-    	if(id == Blocks.GRASS_SCORCHED.id) {
+    	if(id == Blocks.GRASS_SCORCHED.id()) {
     		return Blocks.DIRT_SCORCHED;
     	}
     	return null;
     }
 
     public static boolean canLeavesReplace(World world, int x, int y, int z) {
-        Block b = world.getBlock(x, y, z);
+        Block<?> b = world.getBlock(x, y, z);
         return b == null || b.hasTag(BlockTags.PLACE_OVERWRITES);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java
index c80615e7f..4dd261b95 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java
@@ -119,7 +119,7 @@ public class WorldFeatureTreeCaatinga extends WorldFeature
             return false;
         }
         int idBelow = world.getBlockId(x, y - 1, z);
-        if(!Block.hasTag(idBelow, BlockTags.GROWS_TREES) || y >= world.getHeightBlocks() - l - 1)
+        if(!Blocks.hasTag(idBelow, BlockTags.GROWS_TREES) || y >= world.getHeightBlocks() - l - 1)
         {
             return false;
         }
@@ -174,24 +174,24 @@ public class WorldFeatureTreeCaatinga extends WorldFeature
      * Replace grass blocks below the tree with dirt
      */
     public static void onTreeGrown(World world, int x, int y, int z) {
-        Block dirt = WorldFeatureTree.getDirtForGrass(world.getBlockId(x, y - 1, z));
+        Block<?> dirt = WorldFeatureTree.getDirtForGrass(world.getBlockId(x, y - 1, z));
         if(dirt != null) {
-            world.setBlockWithNotify(x, y - 1, z, dirt.id);
+            world.setBlockWithNotify(x, y - 1, z, dirt.id());
         }
     }
 
-    public static Block getDirtForGrass(int id) {
+    public static Block<?> getDirtForGrass(int id) {
         // TODO make this not hardcoded
-        if(id == Blocks.GRASS.id || id == Blocks.GRASS_RETRO.id) {
+        if(id == Blocks.GRASS.id() || id == Blocks.GRASS_RETRO.id()) {
             return Blocks.DIRT;
         }
-        if(id == Blocks.GRASS_SCORCHED.id) {
+        if(id == Blocks.GRASS_SCORCHED.id()) {
             return Blocks.DIRT_SCORCHED;
         }
         return null;
     }
 
-    static final byte dimensionLookup[] = {
+    static final byte[] dimensionLookup = {
             2, 0, 0, 1, 2, 1
     };
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java
index 3f595d0d2..143898213 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java
@@ -16,14 +16,14 @@ public class WorldFeatureTreeCherry extends WorldFeatureTree {
 	@Override
 	public void placeLeaves(World world, int x, int y, int z, Random rand) {
 		if(rand.nextInt(5) == 0) {
-			world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LEAVES_CHERRY_FLOWERING.id, 0);
+			world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LEAVES_CHERRY_FLOWERING.id(), 0);
 		}else {
-			world.setBlockWithNotify(x, y, z, Blocks.LEAVES_CHERRY.id);
+			world.setBlockWithNotify(x, y, z, Blocks.LEAVES_CHERRY.id());
 		}
 	}
 	
 	@Override
 	public boolean isLeaf(int id) {
-		return id == Blocks.LEAVES_CHERRY_FLOWERING.id || id == Blocks.LEAVES_CHERRY.id;
+		return id == Blocks.LEAVES_CHERRY_FLOWERING.id() || id == Blocks.LEAVES_CHERRY.id();
 	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeEucalyptus.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeEucalyptus.java
index 2a3ed91ff..c70680c36 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeEucalyptus.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeEucalyptus.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world.generate.feature.tree;
 
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -385,7 +385,7 @@ public class WorldFeatureTreeEucalyptus extends WorldFeature
                 origin[0], (origin[1] + height) - 1, origin[2]
         };
         int idBelow = world.getBlockId(origin[0], origin[1] - 1, origin[2]);
-        if(!Block.hasTag(idBelow, BlockTags.GROWS_TREES))
+        if(!Blocks.hasTag(idBelow, BlockTags.GROWS_TREES))
         {
             return false;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancy.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancy.java
index ff113af0e..29c4d4d84 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancy.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world.generate.feature.tree;
 
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -367,7 +367,7 @@ public class WorldFeatureTreeFancy extends WorldFeature
         int[] bottomPos = { origin[0], origin[1], origin[2] };
         int[] topPos = { origin[0], (origin[1] + height) - 1, origin[2] };
         int blockIdUnderneath = world.getBlockId(origin[0], origin[1] - 1, origin[2]);
-        if(!Block.hasTag(blockIdUnderneath, BlockTags.GROWS_TREES))
+        if(!Blocks.hasTag(blockIdUnderneath, BlockTags.GROWS_TREES))
         {
             return false;
         }
